#pragma once

#include "pin.h"
#include "stepper.h"
#include <Arduino.h>

namespace ServoControl{
    unsigned long tlastUp    = 0;
    unsigned long tlastDown  = 0;
    bool lastState  = false;
    unsigned long pulseWidth = 0;
    unsigned long lastpulseWidth = 0;

    void init(){
        pinMode(Pin::SERVO, INPUT);
    }
    void check(){
        bool state = digitalReadFast(Pin::SERVO);
        if(state != lastState){
            lastState = state;
            if(state){
                tlastUp = micros();   //Montant
                Led::ledB(true);
            }else{
                tlastDown = micros(); //Descendant
                pulseWidth = tlastDown - tlastUp;
                
                if(pulseWidth > 200 && abs(lastpulseWidth - pulseWidth) > 20){
                    lastpulseWidth = pulseWidth;
                    int target = ((float(pulseWidth) - 1500.0f)/1500.0f) * Stepper::range;
                    Stepper::setTarget(target);
                    Led::ledB(false);
                }
            }
        }
    }

    bool isEnabled(){
        return true;
    }
} // namespace ServoControl

